var localPreview = false;
localPreview = (document.location === top.location || document.location.toString().indexOf("?localtestpage") !== -1);

function initializeLocalPreview() {
	var ua = navigator.userAgent;
	EB = {
		_adConfig: {
			panels: {
				expand: {
					name: "expand",
					src: "panels/expand/index.html"
				}
			},
			width: 1,
			height: 1,
			adId: 0,
			rnd: 0,
			uid: 0,
			//You only need to add the vars that the workspace script(s) may use, not vars that
			customJSVars: {
				//This will be a different list for each ad format, these are just example vars.
				//are needed only in the custom script.

				//It's only the list of vars that you need to set to stop getting errors when locally previewing
				mdPanelWidthDependency: "browser",
				mdPanelHeightDependency: "adaptive",
				mdPanelAspectRatio: "4:3",
				mdPanelBreakpoints: "300:200,500:300,749:400",
				mdPanelFixedSize: "320x416",
				mdPanelPercentageWidth: 30,
				mdPanelPercentageHeight: 30,
				mdMinPanelWidth: -1,
				mdMinPanelHeight: -1,
				mdBorderStyle: "1px #0d2a4d",
				mdChangeImageOnOrientation: true,
				mdAutoCollapseOnScroll: true,
				mdEnableSDKDefaultCloseButton: false,

				mdAutoSnapType: 3,
				mdCollapseAfterScrollAway: false,
				mdPercentageForSnapIn: 50,
				mdPercentageForSnapOut: 75,
				mdScrollAmountPerTimeUnit: 40,
				mdTopBoundingSelector: null,
				mdBottomBoundingSelector: null,
				mdDisplayTopBar: false,
				mdTopBarLabelStyle: "color:grey;font-size:10px;font-family:arial;text-align:center;",
				mdTopBarLabel: "ADVERTISEMENT",
				mdTopBarHeight: 20,
				mdTopBarColor: "white",
				mdDisplayBottomBar: false,
				mdBottomBarLabelStyle: "color:grey;font-size:10px;font-family:arial;text-align:center;",
				mdBottomBarLabel: "SCROLL TO CONTINUE WITH CONTENT",
				mdBottomBarHeight: 20,
				mdBottomBarColor: "white",
				mdTopBottomBarInCreative: "0000",
				mdInlineScrollReveal: "0000",
				mdDisableInlineSnap: false
			}
		},
		_sendMessage: function (type, data) {
			parent.postMessage({
				type: type,
				data: data
			}, "*");
		},
		API: {
			browser: {
				webkit: ua.match(/webkit/i) !== null,
				firefox: ua.match(/firefox/i) !== null,
				chrome: ua.match(/chrome/i) !== null
			},
			os: {
				ios: ua.match(/ipod|iphone|ipad/i) !== null,
				android: ua.match(/android/i) !== null,
				windowphone: ua.match(/windows phone/i) !== null,
				mobile: ua.match(/ipod|iphone|ipad|android|windows phone/i) !== null,
				ver: ua.match(/os\s\d+/i) !== null ? parseInt(ua.match(/os\s\d+/i).toString().replace(/os\s/i, "")) : null,
				varN: ua.match(/os\s\d+/i) !== null ? parseInt(ua.match(/os\s\d+/i).toString().replace(/os\s/i, "")) : null
			},
			setStyle: function (obj, styles) {
				for (var style in styles) {
					if (!styles.hasOwnProperty(style)) continue;
					obj.style[style] = styles[style];
				}
			},
			getCustomVar: function (name) {
				return EB._adConfig.customJSVars[name];
			},
			Adaptor: {
				getViewPortMetrics: function () {
					return {
						Height: window.innerHeight,
						height: window.innerHeight,
						Width: window.innerWidth,
						width: window.innerWidth
					};
				}
			}
		},
		Comm: {
			setName: function (name) {
				return name;
			},
			isConnected: function (name) {
				return false;
			}
		},
		getSDKData: function () {
			return null;
		},
		expand: function (obj) {
			top.location.replace("panels/" + obj.panelName + "/index.html");
			return true;
		},
		collapse: function (obj) {
			if (document.location.toString().indexOf("panels/expand") !== -1) {
				top.location.replace("../../index.html");
			}
			return true;
		},
		userActionCounter: function () {
			return true;
		},
		clickthrough: function () {
			return true;
		},
		setExpandProperties: function () {
			return true;
		}
	};
	EBG = {
		pm: {
			bind: function () {
				return true;
			}
		},
		px: function (n) {
			return parseInt(n) + "px";
		},
		ActionType: {
			AUTO: function () {
				return "auto";
			},
			USER: function () {
				return "user";
			}
		},
		VideoModule: function (video) {
			return {
				_videoElement: video,
				playVideo: function () {
					this._videoElement.play();
				}
			};
		},
		Adaptors: {
			TagNames: {
				DIV: "div"
			}
		},
		API: {
			InjectionMethod: {
				APPEND: "append"
			},
			Ad: {
				isExpanded: function (uid) {
					return true;
				},
				getAssetUrl: function (uid, asset) {
					return asset;
				},
				getCustomVar: function (uid, name) {
					return EB._adConfig.customJSVars[name];
				},
				setCustomVar: function (uid, varName, defaultValue, override) {
					if (EB._adConfig.customJSVars.hasOwnProperty(varName)) {
						EB._adConfig.customJSVars[varName] = defaultValue;
					}
				}
			},
			Adaptor: {
				setStyle: function (obj, styles) {
					for (var style in styles) {
						if (!styles.hasOwnProperty(style)) continue;
						obj.style[style] = styles[style];
					}
				},
				getElementById: function (id) {
					return document.getElementById(id);
				},
				getViewPortMetrics: function () {
					return {
						Height: window.innerHeight,
						height: window.innerHeight,
						Width: document.body.clientWidth,
						width: document.body.clientWidth
					};
				},
				getPageMetrics: function () {
					return {
						scrollTop: document.body.scrollTop,
						scrollLeft: document.body.scrollLeft,
						scrollWidth: document.body.scrollWidth,
						scrollHeight: document.body.scrollHeight
					};
				},
				getAdData: function (uid, prop) {
					return EB._adConfig[prop];
				},
				inject: function (obj, method, where, uid) {
					var newObj = obj;
					if (method === "append") {
						where.appendChild(newObj);
					}
					return newObj;
				},
				hideScrollBars: function () {
					document.body.style.overflow = "hidden";
				},
				restoreScrollBarsState: function () {
					document.body.style.overflow = "auto";
				}
			},
			Panel: {
				modify: function (uid, panel, css, incIframe) {
					for (var item in css) {
						if (css.hasOwnProperty(item)) {
							css[item] = EBG.px(css[item]);
						}
					}
					EB.API.setStyle(ebAd, css);
					if (incIframe) {
						EB.API.setStyle(ebAd.getElementsByTagName("iframe")[0], css);
					}
				}
			}
		}
	};
	var visibilityStyle = document.createElement("style");
	visibilityStyle.innerHTML = "html, body, div, video {visibility: visible !important;}";
	document.getElementsByTagName("head")[0].appendChild(visibilityStyle);
	dispatchCustomScriptEvent = function () {
		return true;
	};
	if (typeof createTextBar === "function") {
		createTextBar();
	}
	if (typeof creativeContainerReady === "function") {
		creativeContainerReady();
	}
	onPageScroll = function () {
		viewportWidth = window.innerWidth;
		viewportHeight = window.innerHeight;
		adWidth = window.innerWidth;
		adHeight = window.innerHeight;
		adTopPercentage = 100;
		adBottomPercentage = 100;
		adVisiblePercentage = 100;
		isLandscape = viewportWidth > viewportHeight;
	};
	onPageScroll();
	window.addEventListener("resize", onPageScroll);

	// auto expand to panel from 1x1
	if (document.location.toString().indexOf(EB._adConfig.panels.expand.src) === -1) {	
		/* add fake delivery structure */
		document.body.style.margin = 0;
		document.body.style.padding = 0;
		var eyeDivDiv = document.createElement("div");
		eyeDivDiv.setAttribute("id", "eyeDiv");
		document.body.appendChild(eyeDivDiv);
		var adDiv = document.createElement("div");
		adDiv.setAttribute("id", "ebAd");
		adDiv.style.display = "none";
		eyeDivDiv.appendChild(adDiv);
		adFrame = document.createElement("iframe");
		adFrame.setAttribute("frameborder", "0");
		adFrame.setAttribute("scrolling", "no");
		adFrame.setAttribute("src", EB._adConfig.panels.expand.src + "?localtestpage");
		adDiv.appendChild(adFrame);
		var spaceDiv = document.createElement("div");
		spaceDiv.style.height = (window.innerHeight * 1.5) + "px";
		spaceDiv.style.textAlign = "center";
		spaceDiv.innerHTML = "<p style=\"font-family: arial;font-size: 18px;\">Please Scroll Down to Preview the Ad</p>";
		document.body.appendChild(spaceDiv);
		var ebDivDiv = document.createElement("div");
		ebDivDiv.setAttribute("id", "ebDiv");
		document.body.appendChild(ebDivDiv);
		spaceDiv = document.createElement("div");
		spaceDiv.style.height = (window.innerHeight * 1.5) + "px";		
		document.body.appendChild(spaceDiv);
		/* end of fake delivery structure */		
			
		/* add partially custom js for running local preview */
		var uid;
		var browser;
		var os;
		var displayWin = window;
		var displayWinDoc = displayWin.document;
		var displayWinDocBody = displayWinDoc.body;
		var ebDiv;
		var eyeDiv;
		var panelDiv;
		var panelFrame;	
		var panelDocumentLoaded;
		var isInlineScrollReveal = false;
		var disableInlineSnap = true;
		var topMargin = 0;
		var bottomMargin = 0;
		var androidSnapThinLineFix;
		var defaultPanelName = "expand";
		var borders = [];
		var textBars = [];
		var displayTopBar = false;
		var displayBottomBar = false;
		var widgetData = [];
		var widgetPosProps = ["top", "left", "bottom", "right"];
		var widgetSizeProps = ["width", "height"];
		var widgetZindex = 0;
		var adBorderWidth = 0;
		var adBorderColor;
		var initPanelWidthDependency;
		var initPanelHeightDependency;
		var initAutoSnapType;
		var scrollByTotalAmount;
		var scrollUpward;
		var panelScrolledIn;
		var panelIsLocked;
		var adSizeCheckTimer;
		var checkViewPortHeightTimer;
		var executeSnapTimer;
		var snapInAction;
		var snapedIn;
		var snapedOut;
		var userIsTouching;
		var touchStartPoint;
		var touchEndPoint;
		var isBannerReady;
		var isInFullScreenPlayer;
		var isSnappedToSF;
		var isResizing;
		var currentScrollTop;
		var previousTop;
		var previousViewPortWidth;
		var previousViewPortHeight;
		var previousAdTopPercentage;
		var previousClipWidth;
		var previousClipHeight;
		var curScrollPos = {
			scrollXPercent: null,
			scrollYPercent: null
		};
		var pm = {
			topWin: null
		};
		var Const = {
			SNAP_TYPES: {
				DISABLED: 0,
				UPWARD: 1,
				DOWNWARD: 2,
				BOTH_UP_AND_DOWN: 3
			},
			PANEL_SIZE_DEPENDENCY: {
				ADAPTIVE: "adaptive",
				ASPECT_RATIO: "aspectratio",
				PERCENTAGE: "percentage",
				FIXED: "fixed",
				MATCH_BANNER: "matchbanner",
				BROWSER: "browser"
			}
		};

		initCustomVarDefaults = function () {
			for (var cv in EB._adConfig.customJSVars) {
				if (!EB._adConfig.customJSVars.hasOwnProperty(cv)) continue;
				setDefault(cv, EB._adConfig.customJSVars[cv]); // once undefined allowed to be set by type (not "undefined"), replace this line with API setCustomVar
			}
		};

		setDefault = function (varName, defaultValue, optional_override) {
			EBG.API.Ad.setCustomVar(uid, varName, defaultValue, !!optional_override);
			window[varName] = EBG.API.Ad.getCustomVar(uid, varName);
		};

		isInArray = function (item, ary, ignoreCase) {
			var i;
			item = ignoreCase ? item.toLowerCase() : item;
			for (i = 0; i < ary.length; i++) {
				var aryElement = ignoreCase ? ary[i].toLowerCase() : ary[i];
				if (item === aryElement) {
					return true;
				}
			}
			return false;
		};

		isVerticalProperty = function (prop) {
			return isInArray(prop, ["top", "bottom", "height"], true);
		};

		percentageToNumber = function (val, base) {
			if (val.toString().match(/^(-\d+|\d+)%$/) !== null) {
				return parseInt((base / 100) * parseInt(val));
			}
			return parseInt(val);
		};

		getBooleanOption = function (options) {
			var opt = options.toString().split("");
			return {
				desktop: Boolean(opt[0] * 1),
				ios: Boolean(opt[1] * 1),
				android: Boolean(opt[2] * 1),
				windowsphone: Boolean(opt[3] * 1)
			};
		};

		getPreciseViewportSize = function () {
			var viewport = EBG.API.Adaptor.getViewPortMetrics();
			// fix for 43247, EBG.API.Adaptor.getViewPortMetrics does not account for scrollbar width in older version of firefox
			if (browser.firefox) {
				viewport.width = Math.min(displayWin.document.body.offsetWidth, viewport.width);
			}
			if (os.android && screen.width < screen.height) {
				viewport.width = Math.min(screen.width, screen.height);
			}

			return {
				width: viewport.width,
				height: viewport.height
			};
		};

		getPanelBreakPoints = function () {
			if (mdPanelBreakpoints !== undefined) {
				var breakPoints = [];
				var breakPointArray = mdPanelBreakpoints.split(",");
				var breakPointWidth = [];
				var breakPointHeight = [];
				var i;
				var j;
				for (i = 0; i < breakPointArray.length; i++) {
					breakPointWidth[i] = parseInt(breakPointArray[i].split(/[^(\d|\.)]+/)[0]);
				}
				breakPointWidth.sort(function compareNumbers(a, b) {
					return a - b;
				});
				for (i = 0; i < breakPointArray.length; i++) {
					for (j = 0; j < breakPointWidth.length; j++) {
						if (breakPointWidth[j] === parseInt(breakPointArray[i].split(/[^(\d|\.)]+/)[0])) {
							breakPointHeight[j] = parseInt(breakPointArray[i].split(/[^(\d|\.)]+/)[1]);
						}
					}
				}
				for (i = 0; i < breakPointWidth.length; i++) {
					breakPoints[i] = {};
					breakPoints[i].width = breakPointWidth[i];
					breakPoints[i].height = breakPointHeight[i];
				}
				return breakPoints;
			}
			return undefined;
		};

		getPanelFixedSize = function () {
			if (mdPanelFixedSize !== undefined && mdPanelFixedSize.match(/^\d+x\d+$/i) !== null) {
				return {
					width: mdPanelFixedSize.split(/[^(\d|\.)]+/)[0] * 1,
					height: mdPanelFixedSize.split(/[^(\d|\.)]+/)[1] * 1
				};
			}
			else {
				return {
					width: adConfig.width,
					height: adConfig.height
				};
			}
		};

		getPanelLeft = function () {
			if (isInlineScrollReveal) {
				return Math.floor(0 - ((getViewPortWidth() - adConfig.width) / 2));
			}
			if (mdPanelFixedSize !== undefined && mdPanelFixedSize.match(/^\d+x\d+$/i) !== null) {
				return Math.floor((getViewPortWidth() - getPanelWidth()) / 2);
			}
			return 0;
		};

		getPanelWidth = function () {
			var viewportSize = getPreciseViewportSize();
			var panelWidth = getViewPortWidth();
			switch (mdPanelWidthDependency.toLowerCase()) {
			case Const.PANEL_SIZE_DEPENDENCY.FIXED:
				var panelFixedFSize = getPanelFixedSize();
				if (os.mobile) {
					panelWidth = Math.min(panelFixedFSize.width, getViewPortWidth());
				}
				panelWidth = panelFixedFSize.width;
				break;
			case Const.PANEL_SIZE_DEPENDENCY.ADAPTIVE:
				var panelBreakPoints = getPanelBreakPoints();
				if (panelBreakPoints !== undefined) {
					panelWidth = panelBreakPoints[0].width;
					for (var i = 0; i < panelBreakPoints.length; i++) {
						if (panelBreakPoints[i].width <= viewportSize.width) {
							panelWidth = panelBreakPoints[i].width;
						}
					}
				}
				break;
			case Const.PANEL_SIZE_DEPENDENCY.PERCENTAGE:
				if (mdPanelPercentageWidth !== null && !isNaN(mdPanelPercentageWidth)) {
					panelWidth = parseInt((viewportSize.width / 100) * mdPanelPercentageWidth);
					if (mdMinPanelWidth !== -1 && !isNaN(mdMinPanelWidth)) {
						panelWidth = Math.min(panelWidth, mdMinPanelWidth);
					}
				}
				break;
			case Const.PANEL_SIZE_DEPENDENCY.ASPECT_RATIO:
				if (mdPanelAspectRatio !== undefined && mdPanelAspectRatio.match(/\d+:\d+/) !== null) {
					panelWidth = parseInt((getClipHeight() / mdPanelAspectRatio.split(":")[1]) * mdPanelAspectRatio.split(":")[0]);
				}
				break;
			case Const.PANEL_SIZE_DEPENDENCY.MATCH_BANNER:
				panelWidth = adConfig.width;
				break;
			default: //Const.PANEL_SIZE_DEPENDENCY.BROWSER
				panelWidth = getViewPortWidth();
				break;
			}
			return panelWidth;
		};

		getPanelHeight = function () {
			return (getViewPortHeight() - (topMargin + bottomMargin) + androidSnapThinLineFix); // plus 1 to fix the 1px blank underneath the ad
		};

		getClipHeight = function () {
			var viewportSize = getPreciseViewportSize();
			var clipHeight = getPanelHeight();
			switch (mdPanelHeightDependency.toLowerCase()) {
			case Const.PANEL_SIZE_DEPENDENCY.FIXED:
				var panelFixedFSize = getPanelFixedSize();
				if (os.mobile) {
					clipHeight = Math.min(panelFixedFSize.height, getViewPortWidth());
				}
				clipHeight = panelFixedFSize.height;
				break;
			case Const.PANEL_SIZE_DEPENDENCY.ADAPTIVE:
				var panelBreakPoints = getPanelBreakPoints();
				if (panelBreakPoints !== undefined) {
					clipHeight = panelBreakPoints[0].height;
					for (var i = 0; i < panelBreakPoints.length; i++) {
						if (panelBreakPoints[i].width <= viewportSize.width) {
							clipHeight = panelBreakPoints[i].height;
						}
					}
				}
				break;
			case Const.PANEL_SIZE_DEPENDENCY.PERCENTAGE:
				if (mdPanelPercentageHeight !== null && !isNaN(mdPanelPercentageHeight)) {
					clipHeight = parseInt((viewportSize.height / 100) * mdPanelPercentageHeight);
					if (mdMinPanelHeight !== -1 && !isNaN(mdMinPanelHeight)) {
						clipHeight = Math.min(clipHeight, mdMinPanelHeight);
					}
				}
				break;
			case Const.PANEL_SIZE_DEPENDENCY.ASPECT_RATIO:
				if (mdPanelAspectRatio !== undefined && mdPanelAspectRatio.match(/\d+:\d+/) !== null) {
					clipHeight = parseInt((getPanelWidth() / mdPanelAspectRatio.split(":")[0]) * mdPanelAspectRatio.split(":")[1]);
				}
				break;
			case Const.PANEL_SIZE_DEPENDENCY.MATCH_BANNER:
				clipHeight = adConfig.height;
				break;
			default: //Const.PANEL_SIZE_DEPENDENCY.BROWSER
				clipHeight = getPanelHeight();
				break;
			}
			return clipHeight;
		};

		getClipTop = function () {
			try {
				return parseInt(ebDiv.getBoundingClientRect().top - topMargin);
			}
			catch (e) {}
		};

		getClipBottom = function () {
			try {
				return parseInt(ebDiv.getBoundingClientRect().bottom - bottomMargin);
			}
			catch (e) {}
		};

		getBarLeft = function () {
			return isInlineScrollReveal ? 0 : getPanelLeft();
		};

		getTopBarTop = function () {
			try {
				return (isInlineScrollReveal ? 0 : getClipTop()) + adBorderWidth;
			}
			catch (e) {}
		};

		getTopBarHeight = function () {
			return mdDisplayTopBar ? mdTopBarHeight : 0;
		};

		getBottomBarTop = function () {
			try {
				return ((isInlineScrollReveal ? getClipHeight() : getClipBottom()) - (getBottomBarHeight() + adBorderWidth));
			}
			catch (e) {}
		};

		getBottomBarHeight = function () {
			return mdDisplayBottomBar ? mdBottomBarHeight : 0;
		};

		getViewPortHeight = function () {
			return EBG.API.Adaptor.getViewPortMetrics().Height;
		};

		getViewPortWidth = function () {
			return EBG.API.Adaptor.getViewPortMetrics().Width;
		};

		getScrollTop = function () {
			return (displayWin.pageYOffset !== undefined) ? displayWin.pageYOffset : (displayWinDoc.documentElement || displayWinDocBody.parentNode || displayWinDocBody).scrollTop;
		};

		shouldBeResized = function () {
			if (scrollUpward && os.mobile && (ebDiv.getBoundingClientRect().bottom < Math.floor(getViewPortHeight() * 0.90) || ebDiv.getBoundingClientRect().bottom > getViewPortHeight())) {
				return false;
			}
			return true;
		};
		
		dispatchScrollPos = function (useDelay) {
			if (useDelay) {
				window.setTimeout(dispatchScrollPos, 250);
				return;
			}
			var scrollPos = getScrollPos();
			if (isBannerReady && (isResizing || (curScrollPos.scrollXPercent != scrollPos.scrollXPercent || curScrollPos.scrollYPercent != scrollPos.scrollYPercent))) {
				curScrollPos.scrollXPercent = scrollPos.scrollXPercent;
				curScrollPos.scrollYPercent = scrollPos.scrollYPercent;
				//_self.dispatchCustomScriptEvent('pageScroll', scrollPos);
				panelFrame.contentWindow.postMessage(JSON.stringify({
					type: "pageScroll",
					data: scrollPos
				}), "*");
				isResizing = false;
			}
		};		

		getScrollPos = function () {
			var pageMetrics = EBG.API.Adaptor.getPageMetrics(pm.topWin);
			var vp = EBG.API.Adaptor.getViewPortMetrics(pm.topWin);
			var scrollYPercent = 0;
			var scrollXPercent = 0;
			if ((pageMetrics.scrollWidth - vp.width) > 0) {
				scrollXPercent = parseInt((pageMetrics.scrollLeft / (pageMetrics.scrollWidth - vp.width)) * 100);
			}
			if ((pageMetrics.scrollHeight - vp.height) > 0) {
				scrollYPercent = parseInt((pageMetrics.scrollTop / (pageMetrics.scrollHeight - vp.height)) * 100);
			}
			var topPercentage = parseInt((1 - (getClipTop() / vp.height)) * 100);
			var bottomPercentage = parseInt((getClipBottom() / vp.height) * 100);
			var adVisibility = Math.min(Math.max(vp.height - getClipTop(), 0), getClipHeight());
			if (getClipTop() < 0) {
				adVisibility = Math.max(getClipBottom(), 0);
			}
			var visiblePercentage = parseInt((adVisibility / getClipHeight()) * 100);
			var adMetrics = {
				top: getClipTop(),
				bottom: getClipBottom(),
				width: getPanelWidth(),
				height: getClipHeight(),
				topPercentage: topPercentage,
				bottomPercentage: bottomPercentage,
				visiblePercentage: visiblePercentage
			};
			return {
				scrollXPercent: Math.min(Math.max(scrollXPercent, 0), 100),
				scrollYPercent: Math.min(Math.max(scrollYPercent, 0), 100),
				viewPortMetrics: vp,
				adMetrics: adMetrics
			};
		};

		resizeRepositionElements = function () {
			var adIsHidden = false; //_self.checkAdVisibility();
			var viewPortWidth = getViewPortWidth();
			var viewPortHeight = getViewPortHeight();
			var adClipWidth = getPanelWidth();
			var adClipHeight = getClipHeight();
			var scrollPos = getScrollPos();
			var adTopPercentage = scrollPos.adMetrics.topPercentage;
			var i;

			EBG.API.Adaptor.setStyle(ebDiv, {
				display: "block",
				height: EBG.px(adIsHidden ? EBG.API.Ad.getAdData(uid, "height") : adClipHeight),
				width: EBG.px(adIsHidden ? EBG.API.Ad.getAdData(uid, "width") : Math.min(300, adClipWidth))
			});

			EBG.API.Adaptor.setStyle(panelFrame, {
				height: EBG.px(adIsHidden ? EBG.API.Ad.getAdData(uid, "height") : getPanelHeight())
			});

			if (isInlineScrollReveal) {
				EBG.API.Panel.modify(uid, defaultPanelName.toLowerCase(), {
					width: adClipWidth,
					height: adClipHeight
				}, true);
			}
			else {
				EBG.API.Adaptor.setStyle(panelDiv, {
					position: "fixed",
					overflow: "hidden",
					clip: "rect(" + getClipTop() + "px, " + adClipWidth + "px, " + getClipBottom() + "px, 0px)"
				});

				EBG.API.Panel.modify(uid, defaultPanelName.toLowerCase(), {
					width: adClipWidth,
					height: getPanelHeight()
				}, true);
			}

			EBG.API.Panel.modify(uid, defaultPanelName.toLowerCase(), {
				left: getPanelLeft(),
				top: topMargin,
			}, true);

			for (i = 0; i < borders.length; i++) {
				if (borders[i].getAttribute("id").indexOf(uid + "_bottom") !== -1) {
					EBG.API.Adaptor.setStyle(borders[i], {
						top: EBG.px(getClipBottom() - adBorderWidth)	// add 1px fix ONLY for local preview in chrome
					});
				}
				else {
					EBG.API.Adaptor.setStyle(borders[i], {
						top: EBG.px(getClipTop())	// add 1px fix ONLY for local preview in chrome
					});
				}
			}

			if (displayTopBar || displayBottomBar) {
				for (i = 0; i < textBars.length; i++) {
					EBG.API.Adaptor.setStyle(textBars[i].obj, {
						position: "absolute",
						width: EBG.px(adClipWidth),
						top: EBG.px(textBars[i].barName === "top" ? getTopBarTop() : getBottomBarTop()),
						left: EBG.px(getBarLeft())
					});
				}
			}

			runWidgetEffects();

			previousViewPortWidth = viewPortWidth;
			previousViewPortHeight = viewPortHeight;
			previousAdTopPercentage = adTopPercentage;
			previousClipWidth = adClipWidth;
			previousClipHeight = adClipHeight;
		};

		upwardSnapInAnimation = function () {
			if (ebDiv.getBoundingClientRect().top > 0) {
				displayWin.scrollBy(0, mdScrollAmountPerTimeUnit);
				scrollByTotalAmount -= mdScrollAmountPerTimeUnit;
			}
		};

		upwardSnapIn = function () {
			scrollByTotalAmount = Math.ceil(ebDiv.getBoundingClientRect().top - topMargin);
			if (!isInFullScreenPlayer && scrollByTotalAmount > 0) {
				snapInAction = true;
				if (os.windowsphone) {
					displayWin.scrollBy(0, scrollByTotalAmount);
					setTimeout(panelSnapIn, 50);
				}
				else {
					var scrollTimeFrames = Math.floor(scrollByTotalAmount / mdScrollAmountPerTimeUnit);
					for (var i = 0; i < scrollTimeFrames; i++) {
						setTimeout(upwardSnapInAnimation, 10 * i);
					}
					setTimeout(function () {
						if (ebDiv.getBoundingClientRect().top > topMargin) {
							displayWin.scrollBy(0, ebDiv.getBoundingClientRect().top - topMargin);
						}
						panelSnapIn();
					}, 10 * scrollTimeFrames);
				}
			}
		};

		upwardSnapOutAnimation = function () {
			if (ebDiv.getBoundingClientRect().bottom > 0) {
				displayWin.scrollBy(0, mdScrollAmountPerTimeUnit);
				scrollByTotalAmount -= mdScrollAmountPerTimeUnit;
			}
		};

		upwardSnapOut = function () {
			scrollByTotalAmount = Math.ceil(ebDiv.getBoundingClientRect().bottom);
			if (scrollByTotalAmount > 0) {
				snapInAction = true;
				if (os.windowsphone) {
					displayWin.scrollBy(0, scrollByTotalAmount);
					setTimeout(panelSnapOut, 50);
				}
				else {
					var scrollTimeFrames = Math.floor(scrollByTotalAmount / mdScrollAmountPerTimeUnit);
					for (var i = 0; i < scrollTimeFrames - 1; i++) {
						setTimeout(upwardSnapOutAnimation, 10 * i);
					}

					setTimeout(function () {
						if (ebDiv.getBoundingClientRect().bottom > topMargin) {
							displayWin.scrollBy(0, ebDiv.getBoundingClientRect().bottom - topMargin);
						}
						panelSnapOut();
					}, 10 * (scrollTimeFrames - 1));
				}
			}
		};

		downwardSnapInAnimation = function () {
			if (ebDiv.getBoundingClientRect().bottom < getViewPortHeight() - bottomMargin) {
				displayWin.scrollBy(0, 0 - mdScrollAmountPerTimeUnit);
				scrollByTotalAmount -= mdScrollAmountPerTimeUnit;
			}
		};

		downwardSnapIn = function () {
			scrollByTotalAmount = Math.ceil(getViewPortHeight() - (ebDiv.getBoundingClientRect().bottom + bottomMargin));
			if (!isInFullScreenPlayer && scrollByTotalAmount > 0) {
				snapInAction = true;
				if (os.windowsphone) {
					displayWin.scrollBy(0, 0 - scrollByTotalAmount);
					setTimeout(panelSnapIn, 50);
				}
				else {
					var scrollTimeFrames = Math.floor(scrollByTotalAmount / mdScrollAmountPerTimeUnit);
					for (var i = 0; i < scrollTimeFrames - 1; i++) {
						setTimeout(downwardSnapInAnimation, 10 * i);
					}
					setTimeout(function () {
						if (ebDiv.getBoundingClientRect().bottom < getViewPortHeight() - bottomMargin) {
							displayWin.scrollBy(0, 0 - (((getViewPortHeight() - bottomMargin) - ebDiv.getBoundingClientRect().bottom) + androidSnapThinLineFix));
						}
						panelSnapIn();
					}, 10 * (scrollTimeFrames - 1));
				}
			}
		};

		downwardSnapOutAnimation = function () {
			if (ebDiv.getBoundingClientRect().top < getViewPortHeight() - bottomMargin) {
				displayWin.scrollBy(0, 0 - mdScrollAmountPerTimeUnit);
				scrollByTotalAmount -= mdScrollAmountPerTimeUnit;
			}
		};

		downwardSnapOut = function () {
			scrollByTotalAmount = Math.ceil(getViewPortHeight() - ebDiv.getBoundingClientRect().top);
			if (scrollByTotalAmount > 0) {
				snapInAction = true;
				if (os.windowsphone) {
					displayWin.scrollBy(0, 0 - scrollByTotalAmount);
					setTimeout(panelSnapOut, 50);
				}
				else {
					var scrollTimeFrames = Math.floor(scrollByTotalAmount / mdScrollAmountPerTimeUnit);
					for (var i = 0; i < scrollTimeFrames - 1; i++) {
						setTimeout(downwardSnapOutAnimation, 10 * i);
					}

					setTimeout(function () {
						if (ebDiv.getBoundingClientRect().top < getViewPortHeight() - bottomMargin) {
							displayWin.scrollBy(0, 0 - ((getViewPortHeight() - bottomMargin) - ebDiv.getBoundingClientRect().top));
						}
						panelSnapOut();
					}, 10 * (scrollTimeFrames - 1));
				}
			}
		};

		snapAd = function () {
			if (scrollUpward) {
				if (mdAutoSnapType === Const.SNAP_TYPES.UPWARD || mdAutoSnapType === Const.SNAP_TYPES.BOTH_UP_AND_DOWN) {
					if (!snapedIn && ebDiv.getBoundingClientRect().top < (getViewPortHeight() * (100 - mdPercentageForSnapIn)) / 100) {
						upwardSnapIn();
					}
					if (!snapedOut && ebDiv.getBoundingClientRect().bottom < (getViewPortHeight() * (100 - mdPercentageForSnapOut)) / 100) {
						upwardSnapOut();
					}
				}
			}
			else {
				if (mdAutoSnapType === Const.SNAP_TYPES.DOWNWARD || mdAutoSnapType === Const.SNAP_TYPES.BOTH_UP_AND_DOWN) {
					if (!snapedIn && ebDiv.getBoundingClientRect().bottom > (getViewPortHeight() * mdPercentageForSnapIn) / 100) {
						downwardSnapIn();
					}
					if (!snapedOut && ebDiv.getBoundingClientRect().top > (getViewPortHeight() * mdPercentageForSnapOut) / 100) {
						downwardSnapOut();
					}
				}
			}
		};

		/* snap to fullscreen */
		snapToFullscreenMode = function () {
			initPanelWidthDependency = mdPanelWidthDependency;
			initPanelHeightDependency = mdPanelHeightDependency;
			initAutoSnapType = mdAutoSnapType;
			setDefault("mdPanelWidthDependency", "browser", true);
			setDefault("mdPanelHeightDependency", "browser", true);
			setDefault("mdAutoSnapType", 3, true);
			//_handleOntimePageResize();
			resizeRepositionElements();
			setTimeout(function () {
				if (ebDiv.getBoundingClientRect().top > 0) {
					upwardSnapIn();
				}
				else {
					downwardSnapIn();
				}
			}, 50);
			setTimeout(function () {
				isSnappedToSF = true;
			}, 1000);
		};

		/* exit fullscreen */
		exitFullscreenMode = function () {
			setDefault("mdPanelWidthDependency", initPanelWidthDependency, true);
			setDefault("mdPanelHeightDependency", initPanelHeightDependency, true);
			setDefault("mdAutoSnapType", initAutoSnapType, true);
			//_handleOntimePageResize();
			resizeRepositionElements();
			isSnappedToSF = false;
		};

		/* ad border */
		createBorders = function () {
			adBorderWidth = mdBorderStyle.split(" ")[0];
			adBorderColor = mdBorderStyle.split(" ")[1];
			adBorderWidth = (adBorderWidth.match(/^\d+px$/) !== null ? parseInt(adBorderWidth) : 0);
			if (adBorderWidth > 0) {
				for (var i = 0; i < widgetPosProps.length; i++) {
					borders[i] = displayWin.document.createElement("div");
					borders[i].setAttribute("id", "Border_" + uid + "_" + widgetPosProps[i]);
					EBG.API.Adaptor.setStyle(borders[i], {
						position: "absolute",
						height: isVerticalProperty(widgetPosProps[i]) ? EBG.px(adBorderWidth) : "100%",
						width: isVerticalProperty(widgetPosProps[i]) ? "100%" : EBG.px(adBorderWidth),
						fontSize: "0px",
						lineHeight: "1px",
						backgroundColor: adBorderColor,
						zIndex: 99
					});
					if (widgetPosProps[i] === "right") {
						EBG.API.Adaptor.setStyle(borders[i], {
							right: "0px"
						});
					}
					else {
						EBG.API.Adaptor.setStyle(borders[i], {
							left: "0px"
						});
					}
					EBG.API.Adaptor.inject(borders[i], EBG.API.InjectionMethod.APPEND, panelDiv, uid);
				}
			}
		};

		/* widget */
		getWidgetId = function (name) {
			return "Widget_" + uid + "_" + name;
		};

		widgetHandler = function (data) {
			if (data.hasOwnProperty("action") && data.hasOwnProperty("widgetData")) {
				var targetObj = EBG.API.Adaptor.getElementById(getWidgetId(data.widgetData.name));
				if (targetObj) {
					switch (data.action) {
					case "show":
						EBG.API.Adaptor.setStyle(targetObj, {
							display: "block"
						});
						break;
					case "hide":
						EBG.API.Adaptor.setStyle(targetObj, {
							display: "none"
						});
						break;
					case "remove":
						targetObj.parentNode.removeChild(targetObj);
						break;
					case "resizeTo":
						if (data.widgetData.hasOwnProperty("size")) {
							EBG.API.Adaptor.setStyle(targetObj, data.widgetData.size);
							resizeRepositionElements();
						}
						break;
					case "moveTo":
						if (data.widgetData.hasOwnProperty("loc")) {
							for (var loc in data.widgetData.loc) {
								if (isInArray(loc, widgetPosProps, true)) {
									targetObj.setAttribute("origin-" + loc, data.widgetData.loc[loc]);
								}
							}
							EBG.API.Adaptor.setStyle(targetObj, data.widgetData.loc);
							resizeRepositionElements();
						}
						break;
					}
				}
			}
		};

		handleWidgetClick = function (event) {
			var callback = event.target.getAttribute("click-callback") || event.target.parentNode.getAttribute("click-callback");
			if (callback !== null) {
				//_self.CCs[_self.panelFrame.id]._sendMessage(callback);
				panelFrame.contentWindow.postMessage(JSON.stringify({
					type: callback
				}), "*");
			}
		};

		runWidgetEffects = function (init) {
			var adClipWidth = getPanelWidth();
			var adClipHeight = getClipHeight();
			var scrollPos = getScrollPos();
			var adTopPercentage = scrollPos.adMetrics.topPercentage;
			var i;
			var j;

			for (i = 0; i < widgetData.length; i++) {
				if (!widgetData[i].hasOwnProperty("widgetObj")) continue;
				var widgetObj = widgetData[i].widgetObj;
				if (widgetData[i].hasOwnProperty("effects")) {
					var widgetEffects = widgetData[i].effects;
					var supportedEvents = ["scroll", "resize"];
					var supportedCSSProps = (widgetPosProps.concat(widgetSizeProps)).concat(["opacity", "display"]);
					for (j = 0; j < widgetEffects.length; j++) {
						if (!widgetEffects[j].hasOwnProperty("on") || !widgetEffects[j].hasOwnProperty("changeProperty") || !widgetEffects[j].hasOwnProperty("changeTo")) continue;
						var effectProperty = widgetEffects[j].changeProperty.toLowerCase();
						var effectEvent = widgetEffects[j].on.toLowerCase();
						if (!isInArray(effectProperty, supportedCSSProps, true) || !isInArray(effectEvent, supportedEvents, true)) continue;
						var effectTo = widgetEffects[j].changeTo;
						var effectFrom = effectTo;
						var effectStart = 0;
						var effectEnd = 100;
						var effectMin = -1;
						var effectMax = -1;
						var effectAnimation = false;
						var effectDuration = 1.25;
						var effectEasing = "ease-out";
						var corresponding = "auto";
						var isOpacity = effectProperty === "opacity";
						var isDisplay = effectProperty === "display";

						if (widgetEffects[j].hasOwnProperty("changeFrom")) {
							effectFrom = widgetEffects[j].changeFrom;
						}
						if (effectEvent === "scroll") {
							if (widgetEffects[j].hasOwnProperty("scrollFrom")) {
								effectStart = widgetEffects[j].scrollFrom;
							}
							if (widgetEffects[j].hasOwnProperty("scrollTo")) {
								effectEnd = widgetEffects[j].scrollTo;
							}
						}
						if (widgetEffects[j].hasOwnProperty("minChangeTo")) {
							effectMin = parseInt(widgetEffects[j].minChangeTo);
						}
						if (widgetEffects[j].hasOwnProperty("maxChangeTo")) {
							effectMax = parseInt(widgetEffects[j].maxChangeTo);
						}
						if (widgetEffects[j].hasOwnProperty("animation")) {
							effectAnimation = widgetEffects[j].animation;
							if (widgetEffects[j].animation.hasOwnProperty("duration")) {
								effectDuration = widgetEffects[j].animation.duration;
							}
							if (widgetEffects[j].animation.hasOwnProperty("easing")) {
								effectEasing = widgetEffects[j].animation.easing;
							}
						}
						if (effectProperty === "height" && widgetEffects[j].hasOwnProperty("width")) {
							corresponding = widgetEffects[j].width.toLowerCase();
						}
						else if (effectProperty === "width" && widgetEffects[j].hasOwnProperty("height")){
							corresponding = widgetEffects[j].height.toLowerCase();
						}

						var fromPx = isOpacity ? parseFloat(effectFrom) : effectFrom;
						var toPx = isOpacity ? parseFloat(effectTo) : effectTo;
						var propertyUnit;
						var propertyValue = null;
						var correspondingProperty = null;
						var correspondingPropertyValue = null;
						var availableHeight = adClipHeight - (getTopBarHeight() + getBottomBarHeight() + (adBorderWidth * 2));
						var calcBase = isVerticalProperty(effectProperty) ? availableHeight : adClipWidth;

						if (!isOpacity && !isDisplay) {
							fromPx = percentageToNumber(fromPx, calcBase);
							toPx = percentageToNumber(toPx, calcBase);
						}
						switch (effectEvent) {
						case "scroll":
							if (init || previousAdTopPercentage !== adTopPercentage) {
								var thresholds = isOpacity ? 10 : 0;
								if (isDisplay) {
									toPx = toPx.toLowerCase() === "none" ? "none" : "block";
									propertyValue = toPx !== "none" ? "none" : "block";
								}
								if ((init && !isDisplay) || (effectStart <= adTopPercentage + thresholds && adTopPercentage <= effectEnd)) {
									propertyValue = toPx;
									if (!isDisplay && fromPx !== toPx) {
										var effectFrames = Math.abs(effectEnd - effectStart);
										propertyUnit = Math.abs(toPx - fromPx) / effectFrames;
										propertyUnit = isOpacity ? parseFloat(propertyUnit).toFixed(2) : parseInt(propertyUnit);
										if (fromPx <= toPx) {
											propertyValue = fromPx + (propertyUnit * (adTopPercentage - effectStart));
											propertyValue = Math.min(propertyValue, toPx);
										} else {
											propertyValue = fromPx - (propertyUnit * (adTopPercentage - effectStart));
											propertyValue = Math.max(propertyValue, toPx);
										}
									}
								}
							}
							break;
						case "resize":
							if (init || previousClipWidth !== adClipWidth || previousClipHeight !== adClipHeight) {
								propertyValue = toPx;
							}
							break;
						}

						if (propertyValue !== null) {
							if (effectMin !== -1) {
								propertyValue = Math.max(effectMin, propertyValue);
							}
							if (effectMax !== -1) {
								propertyValue = Math.min(effectMax, propertyValue);
							}
							if (effectAnimation) {
								EBG.API.Adaptor.setStyle(widgetObj, {
									webkitTransition: effectProperty + " " + effectDuration + "s",
									transition: effectProperty + " " + effectDuration + "s",
									transitionTimingFunction: effectEasing
								});
							}
							widgetObj.style[effectProperty] = (isDisplay || isOpacity ? propertyValue : EBG.px(propertyValue));
							if (isInArray(effectProperty, widgetPosProps, true)) {
								widgetObj.setAttribute("origin-" + effectProperty, EBG.px(propertyValue));
							}

							if (isInArray(effectProperty, widgetSizeProps)) {
								correspondingProperty = effectProperty === "width" ? "height" : "width";
								if (corresponding !== "nochange") {
									if (corresponding === "auto") {
										correspondingPropertyValue = EBG.px(parseInt((propertyValue / parseInt(widgetData[i].height)) * parseInt(widgetData[i].width)));
										if (correspondingProperty === "height") {
											correspondingPropertyValue = EBG.px(parseInt((propertyValue / parseInt(widgetData[i].width)) * parseInt(widgetData[i].height)));
										}
									}
									else {
										correspondingPropertyValue = EBG.px(percentageToNumber(corresponding, isVerticalProperty(correspondingProperty) ? availableHeight : adClipWidth));
									}
									if (effectAnimation) {
										EBG.API.Adaptor.setStyle(widgetObj, {
											webkitTransition: correspondingProperty + " " + effectDuration + "s",
											transition: correspondingProperty + " " + effectDuration + "s",
											transitionTimingFunction: effectEasing
										});
									}
									widgetObj.style[correspondingProperty] = correspondingPropertyValue;
								}
							}
						}
					}
				}

				if (widgetObj.getAttribute("origin-top") !== null) {
					EBG.API.Adaptor.setStyle(widgetObj, {
						top: EBG.px(getTopBarTop() + getTopBarHeight() + parseInt(widgetObj.getAttribute("origin-top")))
					});
				}
				else if (widgetObj.getAttribute("origin-bottom") !== null) {
					var widgetHeight = parseInt(widgetObj.style.height !== "" ? widgetObj.style.height : 0);
					EBG.API.Adaptor.setStyle(widgetObj, {
						top: EBG.px(getBottomBarTop() - (parseInt(widgetObj.getAttribute("origin-bottom")) + widgetHeight))
					});
				}
				if (widgetObj.getAttribute("origin-left") !== null) {
					EBG.API.Adaptor.setStyle(widgetObj, {
						left: EBG.px(parseInt(widgetObj.getAttribute("origin-left")) + adBorderWidth)
					});				
				}
				else if (widgetObj.getAttribute("origin-right") !== null) {
					EBG.API.Adaptor.setStyle(widgetObj, {
						right: EBG.px(parseInt(widgetObj.getAttribute("origin-right")) + adBorderWidth)
					});					
				}				
			}
		};

		addWidget = function (widget) {
			var widegtObj;
			var widgetStyles = {};
			var widgetProps = widgetPosProps.concat(widgetSizeProps);
			var i;
			var j;

			for (i = 0; i < widgetData.length; i++) {
				if (widgetData[i].name === widget.name && !widgetData[i].widgetObj) {
					widgetData[i].widgetObj = displayWin.document.createElement("div");
					widegtObj = widgetData[i].widgetObj;
					EBG.API.Adaptor.inject(widegtObj, EBG.API.InjectionMethod.APPEND, panelDiv, uid);
					widegtObj.setAttribute("id", getWidgetId(widget.name));
					for (j = 0; j < widgetProps.length; j++) {
						if (widget.hasOwnProperty(widgetProps[j])) {
							var styleValue = widget[widgetProps[j]];
							if (isInArray(widgetProps[j], widgetPosProps, true)) {
								widegtObj.setAttribute("origin-" + widgetProps[j], styleValue);
							}
							if (widgetProps[j] !== "bottom") { // no need to set bottom style, will use top instead (top calculated in runWidgetEffects)
								widgetStyles[widgetProps[j]] = styleValue;
							}
						}
					}
					if (widget.hasOwnProperty("css")) {
						widegtObj.setAttribute("style", widget.css);
					}
					widgetStyles.position = "absolute";
					if (widget.hasOwnProperty("asset")) {
						widgetStyles.backgroundImage = "url(" + EBG.API.Ad.getAssetUrl(uid, widget.asset) + ")";
						if (widegtObj.style.backgroundSize === "") {
							widgetStyles.backgroundSize = "cover";
						}
						if (widget.hasOwnProperty("hover")) {
							widegtObj.setAttribute("onmouseover", "this.style.backgroundImage='url(" + EBG.API.Ad.getAssetUrl(uid, widget.hover) + ")'");
							widegtObj.setAttribute("onmouseout", "this.style.backgroundImage='url(" + EBG.API.Ad.getAssetUrl(uid, widget.asset) + ")'");
						}
					}
					if (widget.hasOwnProperty("html")) {
						widegtObj.innerHTML = widget.html;
					}
					if (widget.hasOwnProperty("callback")) {
						widegtObj.setAttribute("click-callback", widget.callback);
						widegtObj.addEventListener("click", handleWidgetClick);
						EBG.API.Adaptor.setStyle(widegtObj, {
							cursor: "pointer"
						});
					}
					if (widegtObj.style.zIndex === "" || isNaN(widegtObj.style.zIndex)) {
						widgetStyles.zIndex = widgetZindex++;
					}
					EBG.API.Adaptor.setStyle(widegtObj, widgetStyles);
					resizeRepositionElements();
					runWidgetEffects(true);
				}
			}
		};

		createWidgets = function () {
			for (var i = 0; i < widgetData.length; i++) {
				addWidget(widgetData[i]);
			}
			runWidgetEffects(true);
		};

		/* text bars */
		createTextBar = function (bar) {
			var i = textBars.length;
			textBars[i] = {};
			textBars[i].barName = bar;
			textBars[i].obj = displayWin.document.createElement("div");
			textBars[i].obj.setAttribute("id", bar + "TextBar_" + uid);
			bar = bar.charAt(0).toUpperCase() + bar.slice(1);
			EBG.API.Adaptor.setStyle(textBars[i].obj, {
				position: "absolute",
				top: EBG.px(bar === "top" ? getTopBarTop() : getBottomBarTop()),
				left: EBG.px(getBarLeft()),
				width: EBG.px(getPanelWidth()),
				height: EBG.px(eval("md"+ bar + "BarHeight")),
				lineHeight: EBG.px(eval("md"+ bar + "BarHeight")),
				backgroundColor: eval("md"+ bar + "BarColor"),
				zIndex: 98
			});
			textBars[i].obj.style.cssText += ";" + eval("md"+ bar + "BarLabelStyle");
			textBars[i].obj.innerHTML = eval("md"+ bar + "BarLabel");
			EBG.API.Adaptor.inject(textBars[i].obj, EBG.API.InjectionMethod.APPEND, panelDiv, uid);
		};

		removeScrollReveal = function () {
			//EBG.API.Panel.collapse(uid, _self.defaultPanelName.toLowerCase());
			if (ebDiv && ebDiv.parentNode) {
				ebDiv.parentNode.removeChild(ebDiv);
				ebDiv = null;
			}
			mdAutoSnapType = Const.SNAP_TYPES.DISABLED;
		};

		lockDownPanel = function () {
				if (!os.mobile) {
					EBG.API.Adaptor.hideScrollBars();
					currentScrollTop = getScrollTop();
					panelIsLocked = true;
					/*
					if (_self.mdAdBuilder) {
						setTimeout(_self.releasePanel, 500);
					}
					*/
				}
			},

			releasePanel = function () {
				if (!os.mobile && panelIsLocked) {
					EBG.API.Adaptor.restoreScrollBarsState();
					displayWin.scrollTo(0, currentScrollTop);
					_handleOntimePageResize();
					setTimeout(resizeRepositionElements, os.ios || browser.firefox ? 250 : 1);
					panelIsLocked = false;
				}
			};

		collapsePanel = function () {
			//_self.CCs[_self.panelFrame.id]._sendMessage("adCollapsed");
			panelFrame.contentWindow.postMessage(JSON.stringify({
				type: "adCollapsed"
			}), "*");
			removeScrollReveal();
		};

		panelSnapIn = function () {
			snapedIn = true;
			snapInAction = false;
			resizeRepositionElements();
			if (os.mobile && !scrollUpward) {
				checkViewPortHeight();
			}
			if (os.ios) {
				adSizeCheckTimer = setInterval(function () {
					if (ebDiv.getBoundingClientRect().bottom > getViewPortHeight()) {
						_handleOntimePageResize();
						clearInterval(adSizeCheckTimer);
					}
				}, 50);
			}
			previousTop = getScrollTop();
			lockDownPanel();
			//_self.CCs[_self.panelFrame.id]._sendMessage("adSnapIn");
			panelFrame.contentWindow.postMessage(JSON.stringify({
				type: "adSnapIn"
			}), "*");
		};

		panelSnapOut = function () {
			snapedOut = true;
			snapInAction = false;
			previousTop = getScrollTop();

			if (mdCollapseAfterScrollAway && !isInFullScreenPlayer) {
				collapsePanel();
			}

			setTimeout(function () {
				if (!isInFullScreenPlayer) {
					//messageHandlers.ebendvideotimer();
					//_self.CCs[_self.panelFrame.id]._sendMessage("adSnapOut");
					panelFrame.contentWindow.postMessage(JSON.stringify({
						type: "adSnapOut"
					}), "*");
				}
			}, browser.ie ? 1000 : 1);
		};

		panelScrollIn = function () {
				panelScrolledIn = true;
				//_self.CCs[_self.panelFrame.id]._sendMessage("adScrollIn");
				panelFrame.contentWindow.postMessage(JSON.stringify({
					type: "adScrollIn"
				}), "*");
			},

			panelScrollAway = function () {
				if (checkViewPortHeightTimer) {
					clearTimeout(checkViewPortHeightTimer);
				}

				setTimeout(function () {
					panelScrolledIn = false;
					if (!os.mobile) {
						isInFullScreenPlayer = getViewPortHeight() === screen.height;
					}
					if (mdCollapseAfterScrollAway && !isInFullScreenPlayer) {
						collapsePanel();
					}
				}, 250);

				setTimeout(function () {
					if (!isInFullScreenPlayer) {
						try {
							//_self.CCs[_self.panelFrame.id]._sendMessage("adScrollAway");
							panelFrame.contentWindow.postMessage(JSON.stringify({
								type: "adScrollAway"
							}), "*");
							//messageHandlers.ebendvideotimer();
						}
						catch (e) {}
					}
				}, browser.ie ? 1000 : 1);
			};

		checkViewPortHeight = function () {
			if (previousViewPortHeight !== getViewPortHeight()) {
				resizeRepositionElements();
			}
			checkViewPortHeightTimer = setTimeout(checkViewPortHeight, 10);
		};
		
		_handleOntimePageResize = function () {
			isResizing = true;
			dispatchScrollPos();

			if (EBG.API.Ad.isExpanded(uid)) {
				// prevent page zoom
				/*
				if (browser.android) {
					if (getViewPortWidth() < getViewPortHeight()) {
						EBG.API.Panel.modify(uid, defaultPanelName.toLowerCase(), {
							width: Math.min(maxWidthInPortraitMode, getPanelWidth())
						});
					}
					else {
						EBG.API.Panel.modify(uid, defaultPanelName.toLowerCase(), {
							width: Math.min(maxWidthInLandscapeMode, _self.getPanelWidth())
						});
					}
				}
				*/
				if (!shouldBeResized()) {
					return;
				}

				if (!os.mobile) {
					isInFullScreenPlayer = getViewPortHeight() === screen.height;
				}
				/*
				if (os.android && os.ver === 4) {
					if (android4CheckSizeTimer) {
						clearTimeout(android4CheckSizeTimer);
					}
					android4CheckSizeTimer = setTimeout(function () {
						if (getViewPortWidth() > getViewPortHeight()) {
							if (panelDiv.getBoundingClientRect().width < getViewPortWidth()) {
								resizeRepositionElements();
							}
						}
					}, 2000);
				}
				*/
				setTimeout(resizeRepositionElements, os.ios || browser.firefox ? 250 : 1);
			}
		};

		_handleOntimePageScroll = function (event) {
			dispatchScrollPos();

			if (EBG.API.Ad.isExpanded(uid)) {
				if (isSnappedToSF && mdAutoCollapseOnScroll) {
					//_self.CCs[_self.panelFrame.id]._sendMessage("exitFullscreenMode");
					panelFrame.contentWindow.postMessage(JSON.stringify({
						type: "exitFullscreenMode"
					}), "*");
				}
				resizeRepositionElements();
				_handleOntimePageResize();

				var eventType = typeof event !== "undefined" ? "scroll" : "touchend";

				if (executeSnapTimer) {
					clearTimeout(executeSnapTimer);
				}

				if (!panelIsLocked) {
					if (touchStartPoint !== null && touchEndPoint !== null) {
						if (eventType === "scroll") {
							scrollUpward = touchStartPoint > touchEndPoint;
						}
						if (previousTop !== getScrollTop()) {
							scrollUpward = previousTop < getScrollTop();
						}
					}
					else {
						scrollUpward = previousTop < getScrollTop();
					}

					if (eventType === "scroll") {
						previousTop = getScrollTop();
					}

					if ((scrollUpward && ebDiv.getBoundingClientRect().bottom < 0) || (!scrollUpward && ebDiv.getBoundingClientRect().top > getViewPortHeight())) {
						if (panelScrolledIn) {
							panelScrollAway();
						}
					}
					else if ((scrollUpward && ebDiv.getBoundingClientRect().top < getViewPortHeight()) || (!scrollUpward && ebDiv.getBoundingClientRect().bottom > 0)) {
						if (!panelScrolledIn) {
							panelScrollIn();
						}
					}

					if ((ebDiv.getBoundingClientRect().top < getViewPortHeight() && ebDiv.getBoundingClientRect().top > 0) || (ebDiv.getBoundingClientRect().bottom > 0 && ebDiv.getBoundingClientRect().bottom < getViewPortHeight())) {
						EBG.API.Adaptor.setStyle(panelFrame, {
							display: "block"
						});
					}

					if (mdAutoSnapType !== Const.SNAP_TYPES.DISABLED && !snapInAction) {
						executeSnapTimer = setTimeout(function () {
							var doSnap = ((os.mobile && eventType === "touchend") || // when touch end on ios
									(os.ios && eventType === "scroll" && !userIsTouching && getScrollTop() > 0) || // when scroll on ios
									(!os.ios && eventType === "scroll")) // when scroll on other browsers					
								&&
								(!isInlineScrollReveal || (isInlineScrollReveal && !disableInlineSnap));
							if (panelDocumentLoaded && doSnap && !isInFullScreenPlayer) {
								snapAd();
							}
						}, browser.android ? 500 : 100);
					}

					if (snapedIn) {
						snapedIn = false;
					}
					if (snapedOut) {
						snapedOut = false;
					}
				}
			}
		};
		
		panelIsLoaded = function () {
			//if (msg.data.uid === uid) {
				//setTimeout(function () {
					panelDocumentLoaded = true;

					uid = EB._adConfig.uid;
					browser = EB.API.browser;
					os = EB.API.os;

					initCustomVarDefaults();

					if (mdPanelHeightDependency.toLowerCase() === Const.PANEL_SIZE_DEPENDENCY.PERCENTAGE && mdPanelPercentageHeight === 100) {
						setDefault("mdPanelHeightDependency", "browser", true);
					}

					if (mdPanelHeightDependency.toLowerCase() !== Const.PANEL_SIZE_DEPENDENCY.BROWSER) {
						setDefault("mdAutoSnapType", 0, true);
					}		

					displayTopBar = mdDisplayTopBar;
					displayBottomBar = mdDisplayBottomBar;
					if ((displayTopBar || displayBottomBar) && parseInt(mdTopBottomBarInCreative) !== 0) {
						var barInCreativeEnabled = getBooleanOption(mdTopBottomBarInCreative);
						if ((!os.mobile && barInCreativeEnabled.desktop) ||
							(os.ios && barInCreativeEnabled.ios) ||
							(os.android && barInCreativeEnabled.android) ||
							(os.windowsphone && barInCreativeEnabled.windowsphone)) {
							if (displayTopBar) {
								setDefault("_mdDisplayAltTopBar", true, true); // for old ad
								setDefault("mdDisplayAltTopBar", true, true); // for adbuilder logic
								displayTopBar = false;
							}
							if (displayBottomBar) {
								setDefault("_mdDisplayAltBottomBar", true, true); // for old ad
								setDefault("mdDisplayAltBottomBar", true, true); // for adbuilder logic
								displayBottomBar = false;
							}
						}
					}

					androidSnapThinLineFix = os.android ? 1 : 0;				
					
					ebDiv = document.getElementById("ebDiv");
					eyeDiv = document.getElementById("eyeDiv");
					panelDiv = document.getElementById("ebAd");
					panelFrame = panelDiv.getElementsByTagName("iframe")[0];
					if (displayTopBar) {
						createTextBar("top");
					}
					if (displayBottomBar) {
						createTextBar("bottom");
					}
					resizeRepositionElements();
					createBorders();
					createWidgets();
					
					EBG.API.Adaptor.setStyle(panelDiv, {
						display: "block"
					});
					
					window.addEventListener("mouseover", releasePanel, false);
					window.addEventListener("mouseup", releasePanel, false);
					window.addEventListener("mousedown", releasePanel, false);
					window.addEventListener("touchmove", releasePanel, false);
					displayWinDoc.addEventListener("wheel", releasePanel, false);
					if (!browser.firefox) {
						window.addEventListener("mousemove", releasePanel, false);
						displayWinDoc.addEventListener("DOMMouseScroll", releasePanel, false);
					}
					window.addEventListener("resize", _handleOntimePageResize);
					window.addEventListener("scroll", _handleOntimePageScroll);
				//}, 500);
			//}			
		};	

		window.addEventListener("message", function (data) {
			var type = data.data.type;
			var msg = data.data;
			if (type === "addWidget") {
				var SDKData = EB.getSDKData();
				if (SDKData !== null && SDKData.SDKType === "MRAID") {
					if (msg.data.widget.hasOwnProperty("inapp")) {
						if (msg.data.widget.inapp === false) {
							return;
						}
					}
				}
				widgetData.push(msg.data.widget);
				if (panelDiv) {
					addWidget(msg.data.widget);
				}
			}
			else if (type === "widgetHandler") {
				widgetHandler(msg.data);
			}
			else if (type === "creativeWheelScroll") {
				releasePanel();
			}
			else {
				if (typeof window[type] === "function") {
					window[type]();
				}
			}
		});
	}
	else {
		setTimeout(function() {
			window.stop();
		}, 2000);
	}
}